package edu.ndsu.cs.hayden.christensonAssignment3.cayenne.persistent.auto;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Date;
import java.util.List;

import org.apache.cayenne.BaseDataObject;
import org.apache.cayenne.exp.Property;

import edu.ndsu.cs.hayden.christensonAssignment3.cayenne.persistent.Student;

/**
 * Class _Advisor was generated by Cayenne.
 * It is probably a good idea to avoid changing this class manually,
 * since it may be overwritten next time code is regenerated.
 * If you need to make any customizations, please use subclass.
 */
public abstract class _Advisor extends BaseDataObject {

    private static final long serialVersionUID = 1L; 

    public static final String PK_PK_COLUMN = "PK";

    public static final Property<Date> DATE_OF_BIRTH = Property.create("dateOfBirth", Date.class);
    public static final Property<String> MAJOR = Property.create("major", String.class);
    public static final Property<String> NAME = Property.create("name", String.class);
    public static final Property<List<Student>> ADVISEES = Property.create("advisees", List.class);

    protected Date dateOfBirth;
    protected String major;
    protected String name;

    protected Object advisees;

    public void setDateOfBirth(Date dateOfBirth) {
        beforePropertyWrite("dateOfBirth", this.dateOfBirth, dateOfBirth);
        this.dateOfBirth = dateOfBirth;
    }

    public Date getDateOfBirth() {
        beforePropertyRead("dateOfBirth");
        return this.dateOfBirth;
    }

    public void setMajor(String major) {
        beforePropertyWrite("major", this.major, major);
        this.major = major;
    }

    public String getMajor() {
        beforePropertyRead("major");
        return this.major;
    }

    public void setName(String name) {
        beforePropertyWrite("name", this.name, name);
        this.name = name;
    }

    public String getName() {
        beforePropertyRead("name");
        return this.name;
    }

    public void addToAdvisees(Student obj) {
        addToManyTarget("advisees", obj, true);
    }

    public void removeFromAdvisees(Student obj) {
        removeToManyTarget("advisees", obj, true);
    }

    @SuppressWarnings("unchecked")
    public List<Student> getAdvisees() {
        return (List<Student>)readProperty("advisees");
    }

    @Override
    public Object readPropertyDirectly(String propName) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch(propName) {
            case "dateOfBirth":
                return this.dateOfBirth;
            case "major":
                return this.major;
            case "name":
                return this.name;
            case "advisees":
                return this.advisees;
            default:
                return super.readPropertyDirectly(propName);
        }
    }

    @Override
    public void writePropertyDirectly(String propName, Object val) {
        if(propName == null) {
            throw new IllegalArgumentException();
        }

        switch (propName) {
            case "dateOfBirth":
                this.dateOfBirth = (Date)val;
                break;
            case "major":
                this.major = (String)val;
                break;
            case "name":
                this.name = (String)val;
                break;
            case "advisees":
                this.advisees = val;
                break;
            default:
                super.writePropertyDirectly(propName, val);
        }
    }

    private void writeObject(ObjectOutputStream out) throws IOException {
        writeSerialized(out);
    }

    private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
        readSerialized(in);
    }

    @Override
    protected void writeState(ObjectOutputStream out) throws IOException {
        super.writeState(out);
        out.writeObject(this.dateOfBirth);
        out.writeObject(this.major);
        out.writeObject(this.name);
        out.writeObject(this.advisees);
    }

    @Override
    protected void readState(ObjectInputStream in) throws IOException, ClassNotFoundException {
        super.readState(in);
        this.dateOfBirth = (Date)in.readObject();
        this.major = (String)in.readObject();
        this.name = (String)in.readObject();
        this.advisees = in.readObject();
    }

}
